## opentoken 4.0b

=== Build/Makefile ===
# common tasks; see subdirectories for Ada builds

ZIP_VERSION := 4.0a

.PHONY : zip force

source-clean ::
	-find ../ -name "*~" -print | xargs rm -v
	-find ../ -name ".#*" -print | xargs rm -v
	-find ../ -name "*,t" -print | xargs rm -v

linux-clean :
	make -C linux_release distclean
	make -C linux_debug distclean

zip : gzipfile zipfile

gzipfile : force
	rm -rf ../../opentoken-$(ZIP_VERSION)
	mtn checkout --branch org.opentoken ../../opentoken-$(ZIP_VERSION)
	tar -zcf opentoken-$(ZIP_VERSION).tar.gz -C ../.. --exclude=_MTN --exclude=.mtn-ignore --exclude=.dvc-exclude --no-anchor opentoken-$(ZIP_VERSION)

zipfile : force
	cd ../..; zip -q -r opentoken.main/Build/opentoken-$(ZIP_VERSION).zip opentoken-$(ZIP_VERSION) -x "opentoken-$(ZIP_VERSION)/_MTN/*" -x "opentoken-$(ZIP_VERSION)/.mtn-ignore"

debian :
	cp opentoken-$(ZIP_VERSION).tar.gz ../../opentoken-$(ZIP_VERSION)-current/opentoken_$(ZIP_VERSION).orig.tar.gz
	sudo rm -rf ../../opentoken-$(ZIP_VERSION)-current/opentoken-$(ZIP_VERSION)
	mtn checkout --branch org.debian.libopentoken ../../opentoken-$(ZIP_VERSION)-current/opentoken-$(ZIP_VERSION)
	cd ../../opentoken-$(ZIP_VERSION)-current; tar zxf opentoken_$(ZIP_VERSION).orig.tar.gz

tag :
	mtn tag h:org.opentoken opentoken-$(ZIP_VERSION)

# end of file

=== Build/linux_debug/Makefile ===
all: dirs tests examples

# ../../Test/test_one_harness.adb
t_one : test_one_harness.run
t_two : test_debug_harness.run

t_all : test_all_harness.run

one : RUN_ARGS=t
one : association_token_test-run.run

trace :
	addr2line -e token_selection_test-run.exe 0x805b2e7 0x805cfd3 0x8067ed9 0x804d36b 0x40345453

dirs :: lib

lib:
	@mkdir -p lib

clean ::
	@rm -rf lib/*

distclean ::
	@rm -rf lib

include ../common.make

GNAT_PROJECT := opentoken_test.gpr

# Local Variables:
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== Build/linux_release/Makefile ===
# (ediff "../windows_release/Makefile" "../linux_release/Makefile")
# schroot --chroot=unstable -- make -r all

all: tests examples library

# ../../Test/test_one_harness.adb
t_one : test_one_harness.run
t_all : test_all_harness.run

one : bracketed_comment_test-run.run

include ../common.make

# Local Variables:
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== Build/lynx_release/Makefile ===
all: dirs tests

# ../../Test/test_one_harness.adb
one : test_one_harness.run

trace :
	addr2line -e asu_example_5_10_rd-run.exe 0x411a82 0x411aec 0x416f34 0x401783 0x401235 0x401286 0x7c817075

include ../common.make

GNAT_PROJECT := opentoken_test.gpr
GNAT_VERSION := 6.2.1

export ADA_PROJECT_PATH := ../../../sal/build/x86_gnu_lynx_release:../../../makerules

# Local Variables:
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== Build/windows_debug/Makefile ===
all: dirs tests examples

# ../../Test/test_one_harness.adb
t_one : test_one_harness.run
t_all : test_all_harness.run

#one : asu_example_4_46_rd-run.run
#one : asu_example_5_10-run.run
one : asu_example_5_10_rd-run.run
one : RUN_ARGS := < ../../Examples/asu_example_5_10/Example.txt
#one : asu_example_5_10_rd_no_mixin-run.run

trace :
	addr2line -e asu_example_5_10_rd_no_mixin-run.exe 0x413287 0x415c28 0x40ad2a 0x40ad2a 0x40ca38 0x40ad2a 0x40ad2a 0x40ca38 0x40ad2a 0x40ca38 0x418b39 0x401783 0x401235 0x401286 0x7c817075

include ../common.make

GNAT_PROJECT := opentoken_test.gpr
GNAT_VERSION := 6.2.1

# Local Variables:
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== Build/windows_release/Makefile ===
# (ediff "../windows_release/Makefile" "../linux_release/Makefile")

all: tests examples library

# ../../Test/test_one_harness.adb
#t_one : RUN_ARGS := -v
t_one : test_one_harness.run

#one : token_selection_test-run.run
#one : asu_example_5_10_rd-run.run
one : asu_example_5_10_rd-run_bad.run

trace :
	addr2line -e asu_example_5_10_rd-run.exe 0x411a82 0x411aec 0x416f34 0x401783 0x401235 0x401286 0x7c817075

# adactl won't use -gnat05 to create the tree files, so we create the
# tree files via opentoken_tree.gpr. '-- -FT' says don't let adactl
# try.
check : tree
	../../../adactl-1.11r4/src/adactl.exe -f check_package_vars.aru ../../*.ad? ../../Language_Lexers/*.ad? -- -FT -Tobj_tree

tree : force
	gnatmake -P opentoken_tree.gpr

clean ::
	rm -f obj_tree/*

include ../common.make

# Local Variables:
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== debian/changelog ===
opentoken (4.0b-4) unstable; urgency=low

  * Adopting the package. Closes: #73753.
  * Switch to debhelper 9, dpkg-dev and dh-ada-library helpers.
  * Build-Depends: gnat in addition to gnat-4.6 to ensure default compiler.
  * Vcs-*: correct field names and values.
  * Stop depending on inexistant ada-compiler virtual package.
  * Mark lib and -dev packages as Multiarch: same.
  * copyright: update, machine-readable format 1.0.
  * Move runtime tests to debian/tests. XS-Testsuite field accordingly.
  * rules: inherit hardening flags. Do not compress examples. Implement clean.
  * Standards-Version: 3.9.5.
  * source.lintian overrides: -lib does Depend on -dbg.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 30 Nov 2013 15:29:08 +0100

opentoken (4.0b-3) unstable; urgency=low

  * upgrade to gnat-4.6; bump aliversion

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Sun, 10 Jul 2011 15:28:15 -0400

opentoken (4.0b-2) unstable; urgency=low

  * new upstream version 4.0b; packaging changes only
  
  * debian/control (Architecture): change to 'any', matching
    gnat-4.4. Closes: #568450

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Tue, 29 Jun 2010 03:37:18 -0400

opentoken (4.0a-1) unstable; urgency=low

  [Stephen Leake]
  * update to upstream version 4.0a; mtn tag "version_4.0a". Requires
    soversion and aliversion changes.

  [Ludovic Brenta]
  * debian/control (DM-Upload-Allowed): new.   (Uploaders): remove myself.

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Sat, 27 Feb 2010 14:14:22 -0500

opentoken (3.1a-1) unstable; urgency=low

  * update to upstream version 3.1a; mtn tag "version_3.1a". Requires an
    soversion change.

  * control: add aliversion to dev package name, reorder packages, update
    Suggests, Conflicts, Replaces.
    (Build-Depends): update to gnat-4.4
    (Maintainer): change to Stephen Leake
    (Uploaders): add Ludovic Brenta
    (XS-Vcs-Mtn, XS-Vcs-Browser): new
    (* Architecture): update to current gnat list

  * copyright: add Stephen Leake, update to GPL 3

  * <package>.*: delete; easier to maintain in rules file.

  * patches: delete; no longer needed.

  * rules: rewrite, using gnat project files more extensively.

 -- Stephen Leake <stephen_leake@stephe-leake.org>  Wed, 18 Nov 2009 05:42:42 -0500

opentoken (3.0b-11) unstable; urgency=low

  * Include missing language lexer code.
  * Update to Standards-Version 3.8.2 (no changes).

 -- Reto Buerki <reet@codelabs.ch>  Fri, 19 Jun 2009 00:54:05 +0200

opentoken (3.0b-10) unstable; urgency=low

  * Fix wrong-section-according-to-package-name warning.
    - opentoken-dbg: devel -> debug.
  * Tighten dependency to gnat-4.3 (Closes: #533156).
  * Remove unused opentoken-dbg lintian override.
  * Update to Standards-Version 3.8.1 (no changes).
  * Update Debian specific OpenToken project file.

 -- Reto Buerki <reet@codelabs.ch>  Mon, 15 Jun 2009 22:02:36 +0200

opentoken (3.0b-9) unstable; urgency=low

  * Update maintainer e-mail address.
  * Remove "section" field from binary package libopentoken4.

 -- Reto Buerki <reet@codelabs.ch>  Sat, 07 Feb 2009 12:26:58 +0100

opentoken (3.0b-8) unstable; urgency=low

  * Updated to Standards-Version: 3.8.0
  * Added mips and mipsel to 'Architecture' (Closes: #495239).

 -- Reto Buerki <buerki@swiss-it.ch>  Sat, 16 Aug 2008 18:11:21 +0200

opentoken (3.0b-7) unstable; urgency=low

  * Fix compilation issues in ASU_Example_5_10 parser examples
    (Closes: #249915, #249916).

 -- Reto Buerki <buerki@swiss-it.ch>  Tue, 13 May 2008 14:04:32 +0000

opentoken (3.0b-6) unstable; urgency=low

  * Taking over package from Ludovic Brenta (Closes: #477322).
  * Renamed source package to its upstream name.
  * Added debug package opentoken-dbg.
  * Placed DH_COMPAT in debian/compat (removed export from debian/rules).
  * Upgrading package to debhelper 7.
  * Using dpatch for patch management.
  * Changed SONAME to libopentoken.so.4 because of ABI change
    (transition to gnat-4.3) - no other packages affected.
  * Cleanup of debian/rules.

 -- Reto Buerki <buerki@swiss-it.ch>  Sat, 3 May 2008 10:32:08 +0200

libopentoken (3.0b-5) unstable; urgency=medium

  * debian/control (libopentoken3.0b): conflict with, and replace
    libopentoken3.  Closes: #388147.  Thanks, Bill, for reporting this.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 19 Sep 2006 23:40:42 +0200

libopentoken (3.0b-4) unstable; urgency=low

  [Felipe Augusto van de Wiel (faw) <felipe@cathedrallabs.org>]
  * Transition to GCC 4.1.  Closes: #378715.
    - Bump SONAME to 3.0b:
      + changes in debian/rules to allow the use of another SONAME and to
        properly handle the libs
    - Dependency changes in debian/control
      + libopentoken build-depends on gnat (>= 4.1)
      + libopentoken-dev depends on gnat-4.1
      + depends on libopentoken3.0b (to match the new SONAME)
        - rename package libopentoken3 to libopentoken3.0b
  * Changed maintainer e-mail address (requested by him).
  * Removed Uploaders fields (requested by the maintainer).
  * Bump Standards-Version to 3.7.2 (no changes required).
  * Adding architectures supported by gnat-4.1:
    - New arches: amd64 hppa ia64

  [Ludovic Brenta]
  * Many thanks to Felipe for all the hard work.
  * Add alpha and s390, libgnat has just been enabled on these archs.
  * Update the FSF's address in the copyright file.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun,  6 Aug 2006 22:44:15 +0200

libopentoken (3.0b-3) unstable; urgency=low

  * debian/rules (regexp): accept any character in the Debian upload number.
    Closes: #359898.

 -- Ludovic Brenta <ludovic@ludovic-brenta.org>  Sat,  1 Apr 2006 13:46:26 +0200

libopentoken (3.0b-2) unstable; urgency=low

  * debian/control: add support for GNU/kFreeBSD, per request from
    Aurélien Jarno.  Build-depend on gnat (>= 3.15p-19).  Closes: #345191.
  * debian/control: update standards-version to 3.6.2 with no changes.
  * debian/control: update maintainer's email address.


=== debian/control ===
Source: opentoken
Section: libs
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.6,
 dh-ada-library
Standards-Version: 3.9.5
Homepage: http://www.stephe-leake.org/ada/opentoken.html
Vcs-Mtn: www.ada-france.org org.debian.libopentoken
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libopentoken
XS-Testsuite: autopkgtest

Package: libopentoken3-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Conflicts: libopentoken-dev, libopentoken1-dev, libopentoken2-dev
Replaces: libopentoken-dev, libopentoken1-dev, libopentoken2-dev
Description: OpenToken lexical analysis library for Ada (development)
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 This package contains the development files and associated documentation.

Package: libopentoken-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${ada:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: OpenToken lexical analysis library for Ada (debug)
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 This package contains the debug symbols.

Package: libopentoken6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenToken lexical analysis library for Ada (runtime)
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 This package contains the runtime shared library for programs that use
 OpenToken.

=== debian/rules ===
#!/usr/bin/make -f
#
# Debian Makefile for OpenToken
# Copyright (c) 2009-2010 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013      Nicolas Boulenguez <nicolas@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

ADAFLAGS += -gnatfno -gnatwa -gnatVa

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################################################################
POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

PROJECT := debian/opentoken.gpr
override_dh_auto_build-arch:
	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=static \
          $(foreach var,ADAFLAGS,-X$(var)="$($(var))")
	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=dynamic \
          $(foreach var,ADAFLAGS LDFLAGS SOVERSION,-X$(var)="$($(var))")

override_dh_auto_clean:
	rm -f $(foreach k, dynamic static \
             ,$(foreach d, lib obj \
             ,debian/opentoken-$(d)-$(k)/*))

# First package is -dev, but we avoid depending on the aliversion.
override_dh_compress:
	dh_compress --exclude=-dev/examples/
	dh_compress --remaining-packages

######################################################################
RUN_TESTS_TMP := lib$(LIB_NAME)-run-tests-XXXXXXXXXX

# The plural is a lie: only link-with-shared is executed.
# You may run the other test with a manual modification.
# TODO: use adttest and remove all this.

run-tests:
	ADTTMP=`mktemp --tmpdir --directory $(RUN_TESTS_TMP)` && \
        ADTTMP=$$ADTTMP sh debian/tests/link-with-shared 2> $$ADTTMP/stderr; \
        status=$$?; cat $$ADTTMP/stderr; \
        if test $$status != 0; then \
          echo "Test failed: non zero exit status ($$status)."; \
        elif test -s $$ADTTMP/stderr; then \
          echo "Test failed: activity on stderr."; \
        fi; \
        rm -f -r $$ADTTMP

=== debian/tests/control ===
Tests: link-with-shared

Tests: upstream-tests
Depends: @, libaunit2-dev

=== debian/watch ===
version=3
http://www.stephe-leake.org/ada/opentoken.html opentoken-(.*).tar.bz2

## opentoken 5.0a

=== build/Makefile ===
# common tasks; see subdirectories for Ada builds

ZIP_VERSION := 5.0a
#w-$(shell date +%Y-%m-%d)

.PHONY : zip force

doc : ../Docs/wisi-user_guide.info
doc : ../Docs/wisi-user_guide.html

vpath %.texinfo ../Docs

%.info : %.texinfo
	makeinfo $< -o $@

%.html : %.texinfo
	makeinfo --html --no-split $< -o $@

source-clean ::
	-find ../ -name "*~" -delete
	-find ../ -name ".#*" -delete
	-find ../ -name "*,t" -delete

linux-clean :
	make -C linux_release distclean
	make -C linux_debug distclean

zip : source-clean bz2file zipfile

BRANCH := $(notdir $(shell cd ..; pwd))

bz2file : force
	rm -rf ../../$(BRANCH)-$(ZIP_VERSION)
	mtn checkout --branch $(BRANCH) ../../$(BRANCH)-$(ZIP_VERSION)
	tar -c -O  -C ../.. --exclude=_MTN --exclude "build/x86*" --exclude=.mtn-ignore --exclude=.dvc-exclude --exclude debug_parser.adb --no-anchor $(BRANCH)-$(ZIP_VERSION) | bzip2 -9 > $(BRANCH)-$(ZIP_VERSION).tar.bz2

zipfile : ROOT := $(shell cd ..; basename `pwd`)
zipfile : force
	cd ../..; zip -q -r $(CURDIR)/$(ROOT)-$(ZIP_VERSION).zip $(ROOT)-$(ZIP_VERSION) -x "$(ROOT)-$(ZIP_VERSION)/_MTN/*" -x "$(ROOT)-$(ZIP_VERSION)/build/x86_*" -x "$(ROOT)-$(ZIP_VERSION)/.mtn-ignore" -x "$(ROOT)-$(ZIP_VERSION)/.dvc-exclude" -x "$(ROOT)-$(ZIP_VERSION)/debug_parser.adb"

tag :
	mtn tag h:org.opentoken opentoken-$(ZIP_VERSION)

# end of file

=== build/release/Makefile ===
# (ediff "../windows_release/Makefile" "../linux_release/Makefile")
# schroot --chroot=unstable -- make -r all

all: test-clean tests examples library

# ../../Test/test_one_harness.adb
#t_one : RUN_ARGS := -v
t_one : test_one_harness.run
t_all : test_all_harness.diff

# from ../common.make
one : test-clean empty_production_5-parse.diff

trace :
	addr2line -e asu_example_5_10_rd-run.exe 0x411a82 0x411aec 0x416f34 0x401783 0x401235 0x401286 0x7c817075

# adactl won't use -gnat12 to create the tree files, so we create the
# tree files via opentoken_tree.gpr. '-- -FT' says don't let adactl
# try to create the tree.
check : tree
	../../../adactl-1.11r4/src/adactl.exe -f check_package_vars.aru ../../*.ad? ../../Language_Lexers/*.ad? -- -FT -Tobj_tree

tree : force
	gnatmake -P opentoken_tree.gpr

clean ::
	rm -f obj_tree/*

include ../common.make

# Local Variables:
# eval: (load-file "../opentoken.el")
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== debian/changelog ===
opentoken (5.0a-1) unstable; urgency=medium

  * New upstream release relying on gnat-4.9. Closes: #703361.
    Library and -dev packages renamed per Ada policy.
  * New user guide. Lintian override: GFDL, but without invariant section.
    Remove opentoken_developer_tools.html (install documentation).
  * rules: run-tests obsoleted by sadt from devscripts.
  * Upstream files are all executable, fix remaining permissions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 May 2014 14:02:53 +0200

=== debian/control ===
Source: opentoken
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.9,
 dh-ada-library,
 texinfo
# texi2any
Standards-Version: 3.9.5
Homepage: http://www.stephe-leake.org/ada/opentoken.html
Vcs-Mtn: www.ada-france.org org.debian.libopentoken
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libopentoken
XS-Testsuite: autopkgtest

Package: libopentoken4-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: OpenToken lexical analysis library for Ada: development
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 Install this package if you want to write programs that use OpenToken.

Package: libopentoken-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${ada:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: OpenToken lexical analysis library for Ada: debug symbols
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 This package contains the runtime debug symbols.

Package: libopentoken7
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenToken lexical analysis library for Ada: shared library
 OpenToken is a facility for performing token analysis within the Ada language.
 It is designed to provide all the functionality of a traditional lexical
 analyzer generator, such as lex. But due to the magic of inheritance and
 runtime polymorphism it is implemented entirely in Ada as withed-in code. No
 precompilation step is required, and no messy tool-generated source code is
 created.
 .
 This package contains the runtime shared library.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Debian Makefile for OpenToken
 # Copyright (c) 2009-2010 Stephen Leake <stephen_leake@stephe-leake.org>
-# Copyright (c) 2013      Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2014 Nicolas Boulenguez <nicolas@debian.org>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,17 +37,33 @@
 $(POLICY_TARGETS):
 	dh $@ --with ada-library
 
-PROJECT := debian/opentoken.gpr
+PROJECT := debian/$(LIB_NAME).gpr
 override_dh_auto_build-arch:
 	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=static \
           $(foreach var,ADAFLAGS,-X$(var)="$($(var))")
 	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=dynamic \
           $(foreach var,ADAFLAGS LDFLAGS SOVERSION,-X$(var)="$($(var))")
 
-override_dh_auto_clean:
+override_dh_auto_clean::
 	rm -f $(foreach k, dynamic static \
              ,$(foreach d, lib obj \
-             ,debian/opentoken-$(d)-$(k)/*))
+             ,debian/$(LIB_NAME)-$(d)-$(k)/*))
+
+######################################################################
+# Convert wisi user guide to html and txt, so the "docs" file in this
+# directory installs it with hand-written documentations.
+
+WISI_UG := Docs/wisi-user_guide
+
+override_dh_auto_build-arch: $(WISI_UG).html $(WISI_UG).txt
+$(WISI_UG).html: %.html: %.texinfo
+	texi2any --html --no-split $< -o $@
+$(WISI_UG).txt: %.txt: %.texinfo
+	texi2any --plaintext $< -o $@
+override_dh_auto_clean::
+	rm -f $(WISI_UG).html $(WISI_UG).txt
+
+######################################################################
 
 # First package is -dev, but we avoid depending on the aliversion.
 override_dh_compress:
@@ -55,19 +71,7 @@
 	dh_compress --remaining-packages
 
 ######################################################################
-RUN_TESTS_TMP := lib$(LIB_NAME)-run-tests-XXXXXXXXXX
-
-# The plural is a lie: only link-with-shared is executed.
-# You may run the other test with a manual modification.
-# TODO: use adttest and remove all this.
-
-run-tests:
-	ADTTMP=`mktemp --tmpdir --directory $(RUN_TESTS_TMP)` && \
-        ADTTMP=$$ADTTMP sh debian/tests/link-with-shared 2> $$ADTTMP/stderr; \
-        status=$$?; cat $$ADTTMP/stderr; \
-        if test $$status != 0; then \
-          echo "Test failed: non zero exit status ($$status)."; \
-        elif test -s $$ADTTMP/stderr; then \
-          echo "Test failed: activity on stderr."; \
-        fi; \
-        rm -f -r $$ADTTMP
+override_dh_fixperms:
+	dh_fixperms
+	find debian/libopentoken*-dev/usr/share/doc/libopentoken*-dev/examples \
+          -type f -print0 | xargs -0 chmod 644

## opentoken 6.0b

=== build/Makefile ===
# common tasks; see subdirectories for Ada builds

ZIP_VERSION := 6.0b
#w-$(shell date +%Y-%m-%d)

.PHONY : zip force

doc : ../Docs/wisi-user_guide.info
doc : ../Docs/wisi-user_guide.html

vpath %.texinfo ../Docs

%.info : %.texinfo
	makeinfo $< -o $@

%.html : %.texinfo
	makeinfo --html --no-split $< -o $@

source-clean ::
	-find ../ -name "*~" -delete
	-find ../ -name ".#*" -delete
	-find ../ -name "*,t" -delete

linux-clean :
	make -C linux_release distclean
	make -C linux_debug distclean

zip : source-clean bz2file zipfile

BRANCH := $(notdir $(shell cd ..; pwd))

bz2file : force
	rm -rf ../../$(BRANCH)-$(ZIP_VERSION)
	mtn checkout --branch $(BRANCH) ../../$(BRANCH)-$(ZIP_VERSION)
	tar -c -O  -C ../.. --exclude=_MTN --exclude "build/x86*" --exclude=.mtn-ignore --exclude=.dvc-exclude --exclude debug_parser.adb --no-anchor $(BRANCH)-$(ZIP_VERSION) | bzip2 -9 > opentoken-$(ZIP_VERSION).tar.bz2

zipfile : ROOT := $(shell cd ..; basename `pwd`)
zipfile : force
	cd ../..; zip -q -r $(CURDIR)/opentoken-$(ZIP_VERSION).zip $(BRANCH)-$(ZIP_VERSION) -x "$(ROOT)-$(ZIP_VERSION)/_MTN/*" -x "$(ROOT)-$(ZIP_VERSION)/build/x86_*" -x "$(ROOT)-$(ZIP_VERSION)/.mtn-ignore" -x "$(ROOT)-$(ZIP_VERSION)/.dvc-exclude" -x "$(ROOT)-$(ZIP_VERSION)/debug_parser.adb"

tag :
	mtn tag h:org.opentoken opentoken-$(ZIP_VERSION)

# end of file

=== build/debug/Makefile ===
# (ediff "../debug/Makefile" "../release/Makefile")

all: test-clean tests examples library

# ../../Test/test_one_harness.adb
# ../../Test/test_all_harness.adb
#t_one : RUN_ARGS := -v
t_one : test_one_harness.run
t_all : test_all_harness.run

# from ../common.make
# ../../wisi/test/body_instantiation_conflict.wy
one : body_instantiation_conflict-wy.el

EMACS := /apps/emacs-24.2.91/bin/emacs.exe
../../wisi/test/%-wy.el : %.wy
	cd ../../wisi/test; $(EMACS) -batch --no-site-file -l generate-known-good.el -f wisi-generate $(<F)

trace :
	addr2line -e wisi-generate.exe 0x40eb70 0x4214f8 0x401aba 0x402641 0x4013f8 0x74ea33a8 0x77689ef0 0x77689ec3

include ../common.make

# Local Variables:
# eval: (load-file "../opentoken.el")
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== build/profile/Makefile ===
all: clean gprof.out

include ../common.make

%.ads : %.wy wisi-generate.exe
	./wisi-generate.exe --profile $< Ada_Emacs
	dos2unix $@ $*.ads

run_ada_parser.exe : ada_grammar.ads

gmon.out : run_ada_parser.exe
	./run_ada_parser.exe 10 ../../wisi/test/gnatcoll-xref.adb

gprof.out : gmon.out
	gprof run_ada_parser.exe > gprof.out

clean :: gprof_clean
	rm -f obj_tree/*

gprof_clean :
	rm -f *.out

# Local Variables:
# eval: (load-file "../opentoken.el")
# eval: (ada-parse-prj-file "opentoken.prj")
# eval: (ada-select-prj-file "opentoken.prj")
# end:
# end of file

=== build/release/Makefile ===
--- 
+++ 
@@ -9,7 +9,9 @@
 t_all : test_all_harness.diff
 
 # from ../common.make
-one : test-clean empty_production_5-parse.diff
+#one : test-clean
+#one : multi_conflict.ads
+#one : multi_conflict-parse.diff
 
 trace :
 	addr2line -e asu_example_5_10_rd-run.exe 0x411a82 0x411aec 0x416f34 0x401783 0x401235 0x401286 0x7c817075

=== debian/changelog ===
opentoken (6.0b-4) unstable; urgency=medium

  * Split -indep Build-Dependencies and targets. Closes: #806091.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 04 Dec 2015 00:04:42 +0100

opentoken (6.0b-3) unstable; urgency=medium

  * Per Ada policy, 5-dev Breaks/Replaces 4-dev. Closes: #789662.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 23 Jun 2015 21:24:20 +0200

opentoken (6.0b-2) unstable; urgency=medium

  * copyright: add FlightSafety International (spotted by Thorsten Alteholz).
  * Only fix examples permissions if -doc package is built. Closes: #789527.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 22 Jun 2015 00:22:53 +0200

opentoken (6.0b-1) unstable; urgency=medium

  * New upstream release.  Keep lib and -dev package names, as previous
    version will be replaced in the NEW queue and never reach unstable.
  * tests/upstream-tests: new source directories.
  * watch: typo.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 16 May 2015 11:43:20 +0200

opentoken (6.0a-1) unstable; urgency=medium

  * New upstream release. Library and -dev packages renamed per Ada policy.
  * copyright: update, add forgotten names, fix format errors.
  * control: bump Standards-Version, remove automated XS-Testsuite field.
  * watch: mention various monotone branches used by upstream.
  * patches/lalr_list_unrestricted_access.diff: needed to build with gcc-4.9.
  * New -doc package with architecture independent docs.
  * doc-base registration.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 30 Apr 2015 16:19:06 +0200

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,20 @@
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
  gnat, gnat-4.9,
- dh-ada-library,
- texinfo
+ dh-ada-library
+Build-Depends-Indep:
+ ,texinfo
 # texi2any
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.stephe-leake.org/ada/opentoken.html
 Vcs-Mtn: www.ada-france.org org.debian.libopentoken
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libopentoken
-XS-Testsuite: autopkgtest
 
-Package: libopentoken4-dev
+Package: libopentoken5-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
+Breaks: libopentoken4-dev
+Replaces: libopentoken4-dev
 Description: OpenToken lexical analysis library for Ada: development
  OpenToken is a facility for performing token analysis within the Ada language.
  It is designed to provide all the functionality of a traditional lexical
@@ -43,7 +45,7 @@
  .
  This package contains the runtime debug symbols.
 
-Package: libopentoken7
+Package: libopentoken8
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -58,3 +60,18 @@
  created.
  .
  This package contains the runtime shared library.
+
+Package: libopentoken-doc
+Section: doc
+Architecture: all
+Depends: ${misc:Depends}
+Suggests: gnat
+Description: OpenToken lexical analysis library for Ada: documentation
+ OpenToken is a facility for performing token analysis within the Ada language.
+ It is designed to provide all the functionality of a traditional lexical
+ analyzer generator, such as lex. But due to the magic of inheritance and
+ runtime polymorphism it is implemented entirely in Ada as withed-in code. No
+ precompilation step is required, and no messy tool-generated source code is
+ created.
+ .
+ This package contains the documentation.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Debian Makefile for OpenToken
 # Copyright (c) 2009-2010 Stephen Leake <stephen_leake@stephe-leake.org>
-# Copyright (c) 2013-2014 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2015 Nicolas Boulenguez <nicolas@debian.org>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,6 +19,8 @@
 #
 include /usr/share/dpkg/default.mk
 include /usr/share/ada/debian_packaging.mk
+
+DEB_DATE := $(shell dpkg-parsechangelog -S date)
 
 ADAFLAGS += -gnatfno -gnatwa -gnatVa
 
@@ -37,10 +39,18 @@
 $(POLICY_TARGETS):
 	dh $@ --with ada-library
 
+.PHONY: override_dh_auto_clean
+
+######################################################################
 PROJECT := debian/$(LIB_NAME).gpr
+
+.PHONY: override_dh_auto_build-arch
 override_dh_auto_build-arch:
 	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=static \
           $(foreach var,ADAFLAGS,-X$(var)="$($(var))")
+ # Ensure deterministic timestamps in ALI files.
+	find . -depth -name "*.ad[bs]" -a -newermt '$(DEB_DATE)' -print0 | \
+	  xargs -0r touch --no-dereference --date='$(DEB_DATE)'
 	gnatmake $(BUILDER_OPTIONS) -P$(PROJECT) -XKIND=dynamic \
           $(foreach var,ADAFLAGS LDFLAGS SOVERSION,-X$(var)="$($(var))")
 
@@ -55,7 +65,8 @@
 
 WISI_UG := Docs/wisi-user_guide
 
-override_dh_auto_build-arch: $(WISI_UG).html $(WISI_UG).txt
+.PHONY: override_dh_auto_build-indep
+override_dh_auto_build-indep: $(WISI_UG).html $(WISI_UG).txt
 $(WISI_UG).html: %.html: %.texinfo
 	texi2any --html --no-split $< -o $@
 $(WISI_UG).txt: %.txt: %.texinfo
@@ -65,13 +76,16 @@
 
 ######################################################################
 
-# First package is -dev, but we avoid depending on the aliversion.
+.PHONY: override_dh_compress
 override_dh_compress:
-	dh_compress --exclude=-dev/examples/
+	dh_compress --package=libopentoken-doc --exclude=-dev/examples/
 	dh_compress --remaining-packages
 
 ######################################################################
-override_dh_fixperms:
-	dh_fixperms
-	find debian/libopentoken*-dev/usr/share/doc/libopentoken*-dev/examples \
+.PHONY: override_dh_fixperms-arch override_dh_fixperms-indep
+override_dh_fixperms-arch:
+	dh_fixperms --arch
+override_dh_fixperms-indep:
+	dh_fixperms --indep
+	find debian/libopentoken-doc/usr/share/doc/libopentoken-doc/examples \
           -type f -print0 | xargs -0 chmod 644

=== debian/tests/control ===
Tests: link-with-shared

Tests: upstream-tests
Depends: @, libaunit3.7.1-dev

=== debian/watch ===
version=3
http://www.stephe-leake.org/ada/opentoken.html opentoken-(.*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

# These monotone repositories track upstream revisions.  To the extent
# of my understanding, none, even among the tagged ones, matches exactly
# the tar archive contents.
# mtn://www.ada-france.org?org.opentoken
# mtn://www.ada-france.org?org.opentoken.stephe
# mtn://www.ada-france.org?org.opentoken.work_stephe
# mtn://www.ada-france.org?org.opentoken.work_stephe_2
